#! /usr/bin/env racket
#lang racket/gui

(require racket/gui/base)
(require "adif-lexer.rkt")

; Make a frame by instantiating the frame% class
(define frame (new frame% [label "ADIF To CSV"]))
 
; Show the frame by calling its show method
(send frame show #t)

(define msg (new message% [parent frame] [label "ADIF to CSPARC Activity Day CSV Converter"]))

(define adif-in (get-file "ADIF input file" frame #f #f #f null '(("Any" "*.*"))))

(define csv-out (put-file "CSV output file" frame #f
                          (car (string-split (path->string (file-name-from-path adif-in)) ".")) #f null '(("CSV" "*.CSV"))))

(read-adif adif-in)
(print-cpsarc-csv csv-out)
(exit)